{$A+,B-,D+,F-,G+,I-,K+,L+,N-,P-,Q-,R-,S-,T+,V+,W-,X+,Y+}
unit VDongle;
{$C MOVEABLE PRELOAD PERMANENT}	{gleiche Attribute wie Unit SYSTEM}
{Interface-Unit zum Ansprechen von VDONGLE.386. Unter Windows95 wird
 das VxD ggf. dynamisch ge- und entladen, ohne Zutun im Hauptprogramm}
interface
const
 VDongle_Device_ID=$3B48;
{You have been assigned a device ID of 3B48h for your VELGNOD.386 virtual
 device.  This number is uniquely assigned to this device.}
procedure NullFunc;

const
 VDongleEntry: Pointer=@NullFunc;
const
 VxDName:array[0..11]of Char='VDONGLE.386';
 SysName:array[0..11]of Char='VDONGLE.SYS';
 stDriver:array[0..7]of Char='VDongle';
 stDisplay:array[0..21] of Char='Virtual DONGLE Device';
{diese Eintrittspunkte werden beim Start durch 0:32-Adressen ersetzt;
 befinden sich hoffentlich auf aufsteigenden Adressen!}
 NUM_ENTRIES_ADVAPI=11;
 AdvApi:packed record
  case integer of
  1: (	hAdvApi32,
	OpenSCManager,
	CreateService,
	OpenService,
	CloseServiceHandle,
	DeleteService,
	StartService,
	ControlService,
	ChangeServiceConfig,
	RegQueryValueEx,
	RegSetValueEx,
	RegDeleteValue:	LongInt);
  2: (names: array[0..NUM_ENTRIES_ADVAPI] of PChar);
 end=(names: (
	'ADVAPI32.DLL',
	'OpenSCManagerA',
	'CreateServiceA',
	'OpenServiceA',
	'CloseServiceHandle',
	'DeleteService',
	'StartServiceA',
	'ControlService',
	'ChangeServiceConfigA',
	'RegQueryValueExA',
	'RegSetValueExA',
	'RegDeleteValueA'));
const
 NUM_ENTRIES_KERNEL=4;
 Kernel:packed record
  case integer of
  1: (	hKernel32,
	pCreat,
	pIoctl,
	pClose,
	pGetLastError: LongInt);
  2: (names: array[0..NUM_ENTRIES_KERNEL] of PChar);
 end=(names:(
	'KERNEL32.DLL',
	'CreateFileA',
	'DeviceIoControl',
	'CloseHandle',
	'GetLastError'));

function NT_Start: Boolean;
procedure NT_Stop;
function GetLastError: LongInt;

const
 DriverUnloadAtExit: Boolean=FALSE;

implementation

uses WinProcs,WinTypes,Thunk16;
var
 VXDLDR_Entry:Pointer;
 OldExit:Pointer;

procedure NullFunc; assembler;
 asm mov ax,0; stc; end;

const
 stDosDevice:	array[0..15] of Char='\\.\VDONGLE.386';
var
 hVDongle: LongInt;			{WinNT}
 hSCManager: LongInt;			{WinNT}

procedure NTFunc; far; assembler;
{Umsetzung INT2F -> DeviceIOControl}
 var
  IOBuffer,BytesReturned: LongInt;
 asm	pusha
	push	es
	 db $66; xor dx,dx
	 db $66; mov word ptr [BytesReturned],dx
	 db $66; mov word ptr [IOBuffer],dx

	 db $66; push word ptr [hVDongle]	{7 hDevice}
	 mov	dx,ax
	 shl	dx,2
	 add	dh,60h
	 push 40000; push dx		{6 dwIoControlCode}
	 push es; push bx		{5 lpInBuffer=ES:BX}
	 mov	dx,16	{sizeof(TAccessCounter)}
	 cmp	ax,101h
	 je	@@inDX
	 xor	dx,dx
	 cmp	ax,501h
	 je	@@inLen
	 cmp	ax,502h
	 je	@@inLen
	 cmp	ax,503h
	 jne	@@inDX
@@inLen: push	ax
	 push	es
	 push	bx
	  push es; push bx
	  call	lstrlen
	  inc	ax	{Terminator dazu}
	  xchg	dx,ax
	 pop	bx
	 pop	es
	 pop	ax
@@inDX:	 push 0; push dx		{4 nInBufferSize=0/16/lstrlen()+1}
	 mov	dx,16	{sizeof(TAccessCounter)}
	 cmp	ax,1FFh
	 je	@@outPtr
	 mov	dl,8	{sizeof(TFileStatistics)}
	 cmp	ah,6
	 je	@@outPtr
	 lea	si,IOBuffer
	 push ss; push si		{3 lpOutBuffer=@IOBuffer}
	 db $66; push 4			{2 nOutBufferSize=4}
	 jmp	@@w1
@@outPtr:
	 push es; push bx		{3 lpOutBuffer=ES:BX}
	 push 0; push dx		{2 nOutBufferSize=8/16}
@@w1:	 lea	si,BytesReturned
	 push ss; push si		{1 lpBytesReturned=@BytesReturned}
	 db $66; push 0			{0 lpOverlapped=NIL}

	 db $66; push word ptr [Kernel.pIoctl]
	 db $66; push 00101010b		{Pointer-Liste: 00101010}
	 db $66; push 8			{Acht Parameter}
	 call	CallProc32W8
	pop	es
	popa
	cmp	ah,0
	je	@@retAX
	cmp	ax,5FFh
	je	@@retEAX
	cmp	ah,3
	je	@@retAL
	cmp	ah,4
	je	@@retAL
	cmp	ax,5FEh		{DIRTY abfragen}
	je	@@retAL
	cmp	ah,7
	jne	@@e
@@retAL:
	mov	al,byte ptr IOBuffer
	jmp	@@e
@@retEAX:
	db $66
@@retAX:
	mov ax,word ptr IOBuffer
@@e:	clc
 end;

procedure NewExit; far; assembler;
 asm	db $66;	mov ax,word ptr [OldExit]
	db $66;	mov word ptr [ExitProc],ax
	cmp	[DriverUnloadAtExit],0
	jz	@@e
	mov	ax,$0002	{Unload_VxD}
	mov	bx,VDongle_Device_ID
	call	[VXDLDR_Entry]
@@e:
 end;

procedure NT_Stop; assembler;
 asm	db $66; mov ax,word ptr [hVDongle]
	db $66; or ax,ax
	js	@@no_access
	db $66; push ax

	db $66; push word ptr [Kernel.pClose]
	db $66; push 0b
	db $66; push 1
	call	CallProc32W1
	or	al,al
	jz	@@no_access	{nicht OK}
	mov	byte ptr [hVDongle+3],-1	{negativ setzen}
@@no_access:

	cmp	[DriverUnloadAtExit],FALSE
	jz	@@no_stop

	db $66; push word ptr [hSCManager]
	push ds; push offset stDriver
	db $66; push SERVICE_Stop

	db $66; push word ptr [Advapi.OpenService]
	db $66; push 010b
	db $66; push 3
	call	CallProc32W3

	push dx; push ax	{fr CloseServiceHandle}
	 sub	sp,4*7		{Platz fr SERVICE_STATUS}
	 mov	cx,sp		{Zeiger SS:CX}
	 push dx; push ax
	 db $66; push SERVICE_Control_Stop
	 push ss; push cx

	 db $66; push word ptr [Advapi.ControlService]
	 db $66; push 001b
	 db $66; push 3
	 call	CallProc32W3
	 add	sp,4*7		{SERVICE_STATUS uninteressant}

	db $66; push word ptr [Advapi.CloseServiceHandle]
	db $66; push 0b
	db $66; push 1
	call	CallProc32W1

@@no_stop:
	push cs; push offset NullFunc
	db $66; pop word ptr [VDongleEntry]
 end;

procedure NewNTExit; far; assembler;
 asm
	db	$66
	mov	ax,word ptr [OldExit]
	db	$66
	mov	word ptr [ExitProc],ax
	call	NT_Stop

	db $66; push word ptr [hSCManager]
	db $66; push word ptr [Advapi.CloseServiceHandle]
	db $66; push 0b
	db $66; push 1
	call	CallProc32W1

	db $66; push word ptr [Kernel.hKernel32]
	call	FreeLibrary32W
	db $66; push word ptr [Advapi.hAdvApi32]
	call	FreeLibrary32W
 end;

procedure GetVDongleEntry; assembler;
{Eintrittspunkt fr VDONGLE.386 holen}
 asm	xor	di,di
	mov	es,di
	mov	bx,VDongle_Device_ID
	mov	ax,$1684	{Get Device API Entry Point}
	int	$2F
	mov	ax,es
	or	ax,ax
	jz	@@e
	mov	word ptr [VDongleEntry],di
	mov	word ptr [VDongleEntry+2],ax
@@e:
 end;

procedure InitPointers; assembler;
{PE: SI=Zeiger auf hModul, CX=Anzahl Einsprungpunkte}
 asm	push	cx
	 mov	di,si
	 db $66; push word ptr [di]
	 db $66; push 0
	 db $66; push 0
	 call	LoadLibraryEx32W
	 push dx; push ax
	 db $66; pop word ptr [di]
	pop	cx
@@loop:
	push	cx
	 add	di,4
	 db $66; push word ptr [si]
	 db $66; push word ptr [di]
	 call	GetProcAddress32W
	 push dx; push ax
	 db $66; pop word ptr [di]
	pop	cx
	loop	@@loop
 end;

procedure LoadNTDriver; assembler;
 asm	push ds; push offset stDosDevice	{6 lpFileName="\\.\VDONGLE"}
	dw $6866; dd GENERIC_READ OR GENERIC_WRITE
			{5 dwDesiredAccess=GENERIC_READ|GENERIC_WRITE}
	db $66; push 3	{4 dwShareMode=FILE_SHARE_READ|FILE_SHARE_WRITE}
	db $66; push 0	{3 lpSecurityAttributes=NULL}
	db $66; push 3	{2 dwCreationDistribution=OPEN_EXISTING}
	dw $6866; dd 00000080h;
{1 dwFlagsAndAttributes=/*FILE_FLAG_DELETE_ON_CLOSE*/|FILE_ATTRIBUTE_NORMAL}
	db $66; push 0			{0 hTemplateFile=0}

	db $66; push word ptr [Kernel.pCreat]
	db $66; push 1000000b
	db $66; push 7			{Sieben Parameter}
	call	CallProc32W7
	push	dx
	push	ax
	db $66; pop ax
	db $66; mov word ptr [hVDongle],ax
	db $66; or ax,ax
	js	@@e
	jz	@@e
	push cs; push offset NTFunc
	db $66; pop word ptr [VDongleEntry]
@@e:
 end;

function NT_Start: Boolean; assembler;
 asm
	call	LoadNTDriver
	jns	@@no_start

	db $66; push word ptr [hSCManager]
	push ds; push offset stDriver
	db $66; push SERVICE_Start

	db $66; push word ptr [AdvApi.OpenService]
	db $66; push 010b
	db $66; push 3
	call	CallProc32W3
	mov	cx,ax
	or	cx,dx
	jcxz	@@err

	push dx; push ax	{fr CloseServiceHandle}
	 push dx; push ax
	 db $66; push 0
	 db $66; push 0

	 db $66; push word ptr [AdvApi.StartService]
	 db $66; push 000b
	 db $66; push 3
	 call	CallProc32W3
@@startOK:
	mov	[DriverUnloadAtExit],TRUE
	db $66; push word ptr [AdvApi.CloseServiceHandle]
	db $66; push 0b
	db $66; push 1
	call	CallProc32W1

	call	LoadNTDriver
	jns	@@no_start
@@err:	mov	al,FALSE
	jmp	@@e
@@no_start:
	mov	al,TRUE
@@e:
 end;

function GetLastError: LongInt; assembler;
 asm	db $66; push word ptr [Kernel.pGetLastError]
	db $66; push 0b
	db $66; push 0
	call	CallProc32W0
 end;

begin	{Initialisierung}
 asm	call	GetWinFlags
	test	ax,WF_WinNT
	jz	@@no_nt
	mov	si,offset Kernel
	mov	cx,NUM_ENTRIES_KERNEL
	call	InitPointers
	mov	si,offset AdvApi
	mov	cx,NUM_ENTRIES_ADVAPI
	call	InitPointers

	db $66; push 0
	db $66; push 0
	dw $6866; dd GENERIC_READ

	db $66; push word ptr [AdvApi.OpenSCManager]
	db $66; push 000b
	db $66; push 3
	call	CallProc32W3
	push dx; push ax
	db $66; pop word ptr [hSCManager]

	call	NT_Start
	push cs; push offset NewNTExit
	jmp	@@set
@@no_nt:
	call	GetVDongleEntry
	jnz	@@e		{ja, statisch geladen!}
	mov	bx,$0027	{VXDLDR-Device-ID}
	mov	ax,$1684
	int	$2F
	mov	ax,es
	or	ax,ax		{<>0?}
	jz	@@e		{nein, wohl kein Windows95?}
	mov	word ptr [VXDLDR_Entry],di
	mov	word ptr [VXDLDR_Entry+2],ax
	mov	dx,offset VxDName
	mov	ax,$0001	{Load_VxD}
	call	[VXDLDR_Entry]
	jc	@@e		{Fehler!}
	mov	[DriverUnloadAtExit],TRUE
	call	GetVDongleEntry	{Zweiter Versuch}
	push cs; push offset NewExit
@@set:
	db $66;	pop ax
	db $66;	xchg word ptr [ExitProc],ax
	db $66;	mov word ptr [OldExit],ax
@@e: end;
end.
